using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;

/// <summary>
/// Output CSS file storage
/// </summary>
public class CMSOutputCSS
{
    private string mOutputData = null;
    private DateTime mLastModified = DateTime.Now;
    private string mVersionGUID = null;


    /// <summary>
    /// Output file data.
    /// </summary>
    public string OutputData
    {
        get
        {
            return mOutputData;
        }
        set
        {
            mOutputData = value;
        }
    }


    /// <summary>
    /// Time when the file was last modified
    /// </summary>
    public DateTime LastModified
    {
        get
        {
            return mLastModified;
        }
        set 
        {
            mLastModified = value;
        }
    }


    /// <summary>
    /// Version GUID
    /// </summary>
    public string VersionGUID
    {
        get
        {
            return mVersionGUID;
        }
        set
        {
            mVersionGUID = value;
        }
    }


    /// <summary>
    /// Constructor.
    /// </summary>
    public CMSOutputCSS()
    {
    }


    /// <summary>
    /// Constructor.
    /// </summary>
    /// <param name="ai">Stylesheet info</param>
    /// <param name="data">Output file data</param>
    public CMSOutputCSS(string data, string versionGuid)
    {
        this.OutputData = data;
        this.VersionGUID = versionGuid;
    }
}
