using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.ExtendedControls;
using CMS.WorkflowEngine;
using CMS.CMSHelper;

public partial class CMSDesk_Content_Properties_menu : CMSDeskPage
{
    int nodeId = 0;
    protected bool hasModifyPermission = true;

    protected void Page_Load(object sender, EventArgs e)
    {
        this.PreRender += new EventHandler(Page_PreRender);

        nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);

        lblMenuCaption.Text = ResHelper.GetString("MenuProperties.Caption");
        lblMenuItemStyle.Text = ResHelper.GetString("MenuProperties.Style");
        lblMenuItemLeftmage.Text = ResHelper.GetString("MenuProperties.LeftImage");
        lblMenuItemImage.Text = ResHelper.GetString("MenuProperties.Image");
        lblMenuItemRightImage.Text = ResHelper.GetString("MenuProperties.RightImage");
        lblShowInNavigation.Text = ResHelper.GetString("MenuProperties.ShowInNavigation");
        lblShowInSitemap.Text = ResHelper.GetString("MenuProperties.ShowInSitemap");
        btnOK.Text = ResHelper.GetString("MenuProperties.btnOK");

        lblMenuItemDesign.Text = ResHelper.GetString("MenuProperties.Design");
        lblMenuItemDesignOnMouseOver.Text = ResHelper.GetString("MenuProperties.MouseOver");
        lblMenuItemDesignHighlighted.Text = ResHelper.GetString("MenuProperties.Highlight");

        lblCssClass.Text = ResHelper.GetString("MenuProperties.CssClass");
        lblCssClassHighlight.Text = ResHelper.GetString("MenuProperties.CssClass");
        lblCssClassMouseOver.Text = ResHelper.GetString("MenuProperties.CssClass");

        lblMenuItemStyleHighlight.Text = ResHelper.GetString("MenuProperties.Style");
        lblMenuItemStyleMouseOverr.Text = ResHelper.GetString("MenuProperties.Style");

        lblMenuItemImageHighlight.Text = ResHelper.GetString("MenuProperties.Image");
        lblMenuItemImageMouseOver.Text = ResHelper.GetString("MenuProperties.Image");

        lblMenuItemLeftmageHighlight.Text = ResHelper.GetString("MenuProperties.LeftImage");
        lblMenuItemLeftmageMouseOver.Text = ResHelper.GetString("MenuProperties.LeftImage");

        lblMenuItemRightImageHighlight.Text = ResHelper.GetString("MenuProperties.RightImage");
        lblMenuItemRightImageMouseOver.Text = ResHelper.GetString("MenuProperties.RightImage");

        lblMenuActions.Text = ResHelper.GetString("MenuProperties.MenuActions");
        radInactive.Text = ResHelper.GetString("MenuProperties.Inactive");
        radJavascript.Text = ResHelper.GetString("MenuProperties.Javascript");
        radStandard.Text = ResHelper.GetString("MenuProperties.Standard");
        radUrl.Text = ResHelper.GetString("MenuProperties.Url");
        lblUrlInactive.Text = ResHelper.GetString("MenuProperties.InactivateUrl");

        radInactive.Attributes.Add("onclick", "enableTextBoxes('inactive')");
        radStandard.Attributes.Add("onclick", "enableTextBoxes('')");
        radUrl.Attributes.Add("onclick", "enableTextBoxes('url')");
        radJavascript.Attributes.Add("onclick", "enableTextBoxes('java')");

        

        if (!this.IsPostBack)
        {
            ReloadData();
        }
    }


    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (hasModifyPermission)
        {
            this.pnlForm.Enabled = this.menuElem.AllowEdit;
        }
        this.lblWorkflowInfo.Text = this.menuElem.WorkflowInfo;
        this.lblWorkflowInfo.Visible = (this.lblWorkflowInfo.Text != "");
    }


    /// <summary>
    /// Reload data
    /// </summary>
    private void ReloadData()
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        //tree.SelectSingleNode(nodeId);
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        if (node != null)
        {
            // Check read permissions
            if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Read) == AuthorizationResultEnum.Denied)
            {
                CMSDeskPage.RedirectToAccessDenied(String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoreaddocument"), node.NodeAliasPath));
            }
            // Check modify permissions
            else if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Modify) == AuthorizationResultEnum.Denied)
            {
                hasModifyPermission = false;
                this.pnlForm.Enabled = false;
                this.lblWorkflowInfo.Text = String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoeditdocument"), node.NodeAliasPath);
            }

            this.txtMenuCaption.Text = node.DocumentMenuCaption;
            this.txtMenuItemStyle.Text = node.DocumentMenuStyle;
            this.txtMenuItemImage.Text = node.DocumentMenuItemImage;
            this.txtMenuItemLeftImage.Text = node.DocumentMenuItemLeftImage;
            this.txtMenuItemRightImage.Text = node.DocumentMenuItemRightImage;

            if (node.GetValue("DocumentMenuItemHideInNavigation") != null)
            {
                this.chkShowInNavigation.Checked = !(Convert.ToBoolean(node.GetValue("DocumentMenuItemHideInNavigation")));
            }
            else
            {
                this.chkShowInNavigation.Checked = false;
            }


            this.chkShowInSitemap.Checked = Convert.ToBoolean(node.GetValue("DocumentShowInSiteMap"));


            this.txtCssClass.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuClass"), "");

            this.txtMenuItemStyleMouseOver.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuStyleOver"), "");
            this.txtCssClassMouseOver.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuClassOver"), "");
            this.txtMenuItemImageMouseOver.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemImageOver"), "");
            this.txtMenuItemLeftImageMouseOver.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemLeftImageOver"), "");
            this.txtMenuItemRightImageMouseOver.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemRightImageOver"), "");

            this.txtMenuItemStyleHighlight.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuStyleHighlighted"), "");
            this.txtCssClassHighlight.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuClassHighlighted"), "");
            this.txtMenuItemImageHighlight.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemImageHighlighted"), "");
            this.txtMenuItemLeftImageHighlight.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemLeftImageHighlighted"), "");
            this.txtMenuItemRightImageHighlight.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuItemRightImageHighlighted"), "");



            //Menu Action
            SetRadioActions(0);
            
            // Menu action priority low to high !
            if (ValidationHelper.GetString(node.GetValue("DocumentMenuJavascript"), "") != "")
            {
                txtJavaScript.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuJavascript"), "");
                SetRadioActions(2);
            }

            if (ValidationHelper.GetString(node.GetValue("DocumentMenuRedirectUrl"), "") != "")
            {
                txtUrlInactive.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuRedirectUrl"), "");
                txtUrl.Text = ValidationHelper.GetString(node.GetValue("DocumentMenuRedirectUrl"), "");
                SetRadioActions(3);
            }

            if (ValidationHelper.GetBoolean(node.GetValue("DocumentMenuItemInactive"), false))
            {
                SetRadioActions(1);
            }
        }
    }

    /// <summary>
    /// Set radio buttons for menu action
    /// </summary>
    /// <param name="action"></param>
    private void SetRadioActions(int action)
    {
        radInactive.Checked = false;
        radStandard.Checked = false;
        radUrl.Checked = false;
        radJavascript.Checked = false;

        txtJavaScript.Enabled = false;
        txtUrl.Enabled = false;

        switch (action)
        {
            case 1:
                {
                    ltlScript.Text = ScriptHelper.GetScript("enableTextBoxes('inactive');");
                    radInactive.Checked = true; 
                    break;
                }
            case 2:
                {
                    ltlScript.Text = ScriptHelper.GetScript("enableTextBoxes('java');");
                    radJavascript.Checked = true; 
                    txtJavaScript.Enabled = true; 
                    break;
                }
            case 3:
                {
                    ltlScript.Text = ScriptHelper.GetScript("enableTextBoxes('url');");
                    radUrl.Checked = true; 
                    txtUrl.Enabled = true; 
                    break;
                }
            default:
                {
                    ltlScript.Text = ScriptHelper.GetScript("enableTextBoxes('');");
                    radStandard.Checked = true;
                    break;
                }
        }

    }

    protected void btnOK_Click(object sender, EventArgs e)
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        //tree.SelectSingleNode(nodeId);
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);
        if (node != null)
        {
            bool autoCheck = !VersionManager.UseCheckInCheckOut(CMSContext.CurrentSite.SiteName);
            VersionManager vm = null;
            bool useWorkflow = false;
            WorkflowManager workflowMan = new WorkflowManager();

            // Get the document
            node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

            //test if the document uses workflow
            if (workflowMan.GetNodeWorkflowScope(node) != null)
            {
                useWorkflow = true;
            }

            // If not using check-in/check-out, check out automatically
            if (autoCheck & useWorkflow)
            {
                if (node != null)
                {
                    // Check out
                    vm = new VersionManager(tree);
                    vm.CheckOut(node);
                }
            }

            // Update the data
            node.DocumentMenuCaption = this.txtMenuCaption.Text.Trim();
            node.DocumentMenuItemImage = this.txtMenuItemImage.Text.Trim();
            node.DocumentMenuItemLeftImage = this.txtMenuItemLeftImage.Text.Trim();
            node.DocumentMenuItemRightImage = this.txtMenuItemRightImage.Text.Trim();
            node.DocumentMenuStyle = this.txtMenuItemStyle.Text.Trim();
            node.SetValue("DocumentMenuItemHideInNavigation", !this.chkShowInNavigation.Checked);
            node.SetValue("DocumentShowInSiteMap", this.chkShowInSitemap.Checked);


            node.SetValue("DocumentMenuClass", this.txtCssClass.Text.Trim());

            node.SetValue("DocumentMenuStyleOver", this.txtMenuItemStyleMouseOver.Text.Trim());
            node.SetValue("DocumentMenuClassOver", this.txtCssClassMouseOver.Text.Trim());
            node.SetValue("DocumentMenuItemImageOver", this.txtMenuItemImageMouseOver.Text.Trim());
            node.SetValue("DocumentMenuItemLeftImageOver", this.txtMenuItemLeftImageMouseOver.Text.Trim());
            node.SetValue("DocumentMenuItemRightImageOver", this.txtMenuItemRightImageMouseOver.Text.Trim());

            node.SetValue("DocumentMenuStyleHighlighted", this.txtMenuItemStyleHighlight.Text.Trim());
            node.SetValue("DocumentMenuClassHighlighted", this.txtCssClassHighlight.Text.Trim());
            node.SetValue("DocumentMenuItemImageHighlighted", this.txtMenuItemImageHighlight.Text.Trim());
            node.SetValue("DocumentMenuItemLeftImageHighlighted", this.txtMenuItemLeftImageHighlight.Text.Trim());
            node.SetValue("DocumentMenuItemRightImageHighlighted", this.txtMenuItemRightImageHighlight.Text.Trim());

            // Menu action
            txtJavaScript.Enabled = false;
            txtUrl.Enabled = false;
            
            if (radStandard.Checked)
            {
                node.SetValue("DocumentMenuRedirectUrl", "");
                node.SetValue("DocumentMenuJavascript", "");
                node.SetValue("DocumentMenuItemInactive", false);
            }

            if (radInactive.Checked)
            {
                ltlScript.Text = ScriptHelper.GetScript("enableTextBoxes('inactive');");   
                node.SetValue("DocumentMenuRedirectUrl", txtUrlInactive.Text);
                node.SetValue("DocumentMenuJavascript", txtJavaScript.Text);
                node.SetValue("DocumentMenuItemInactive", true);
            }

            if (radJavascript.Checked)
            {
                txtJavaScript.Enabled = true;
                txtUrl.Enabled = false;
                node.SetValue("DocumentMenuRedirectUrl", "");
                node.SetValue("DocumentMenuJavascript", txtJavaScript.Text);
                node.SetValue("DocumentMenuItemInactive", false);
            }
            
            if (radUrl.Checked)
            {
                txtJavaScript.Enabled = false;
                txtUrl.Enabled = true;
                node.SetValue("DocumentMenuRedirectUrl", txtUrl.Text);
                node.SetValue("DocumentMenuJavascript", "");
                node.SetValue("DocumentMenuItemInactive", false);
            }
            
            DocumentHelper.UpdateDocument(node, tree);
            //node.Update();

            // Check in the document
            if (autoCheck & useWorkflow)
            {
                vm.CheckIn(node, null, null);
            }

            this.menuElem.ReloadMenu();
            
            this.lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
        }
    }
}
