using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.ExtendedControls;
using CMS.WorkflowEngine;
using CMS.PortalEngine;

public partial class CMSDesk_Content_Properties_template : CMSDeskPage, ICallbackEventHandler
{
    int nodeId = 0;
    protected string mSave = null;
    protected string mInherit = null;
    protected string mClone = null;
    protected string mEditTemplateProperties = null;

    private string btnSaveOnClickScript = "";
    private int siteid = 0;

    private int cloneId = 0;

    string imagesUrl = null;
    protected bool hasModifyPermission = true;

    CMS.TreeEngine.TreeNode node = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        imagesUrl = ResolveUrl("~/App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Content/Properties/Template/");

        // Register the script to perform get flags for showing buttons retrieval callback (if template is selected from dialog)
        Page.ClientScript.RegisterClientScriptBlock(GetType(), "ShowButtonFlags", ScriptHelper.GetScript("function GetShowButtonFlags(templateId){ return " + this.Page.ClientScript.GetCallbackEventReference(this, "templateId", "ReceiveShowButtonFlags", null) + " } \n"));

        // Register the dialog script
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        this.ltlElemScript.Text += ScriptHelper.GetScript(
            "var cloneElem = document.getElementById('" + this.btnClone.ClientID + "'); \n" +
                "if (cloneElem != null) var cloneElemStyle = (cloneElem.style != null) ? cloneElem.style : cloneElem; \n" +
            "var inheritElem = document.getElementById('" + this.btnInherit.ClientID + "'); \n" +
                "if (inheritElem != null) var inheritElemStyle = (inheritElem.style != null) ? inheritElem.style : inheritElem; \n" +
            "var saveElem = document.getElementById('" + this.btnSave.ClientID + "'); \n" +
                "if (saveElem != null) var saveElemStyle = (saveElem.style != null) ? saveElem.style : saveElem; \n" +
            "var editTemplatePropertiesElem = document.getElementById('" + this.btnEditTemplateProperties.ClientID + "'); \n" +
                "if (editTemplatePropertiesElem != null) var editTemplatePropertiesElemStyle = (editTemplatePropertiesElem.style != null) ? editTemplatePropertiesElem.style : editTemplatePropertiesElem; \n"
            );

        this.PreRender += new EventHandler(Page_PreRender);

        nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);

        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        if (node != null)
        {
            siteid = node.NodeSiteID;
        }

        txtTemplate.Text = ValidationHelper.GetString(Request.Params["txtTemplate"], "");
        lblTemplate.Text = ResHelper.GetString("PageProperties.Template");
        lblLevels.Text = ResHelper.GetString("PageProperties.InheritLevels");

        mClone = ResHelper.GetString("PageProperties.Clone");
        mSave = ResHelper.GetString("PageProperties.Save");
        mInherit = ResHelper.GetString("PageProperties.Inherit");
        mEditTemplateProperties = ResHelper.GetString("PageProperties.EditTemplateProperties");
        this.imgClone.ImageUrl = imagesUrl + "clone.gif";
        this.imgInherit.ImageUrl = imagesUrl + "inherit.gif";
        this.imgSave.ImageUrl = imagesUrl + "save.gif";
        this.imgEditTemplateProperties.ImageUrl = imagesUrl + "edit.gif";

        btnSelect.Text = ResHelper.GetString("PageProperties.Select");
        btnSelect.Attributes.Add("onclick", "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SelectTemplate.aspx") + "', 'Page template selection', 700, 440);return false;");

        btnEditTemplateProperties.Attributes.Add("onclick", "modalDialog('" + ResolveUrl("~/CMSSiteManager/Development/PageTemplates/PageTemplate_Edit.aspx") + "?templateid=' + document.getElementById('SelectedTemplateId').value + '&nobreadcrumbs=1', 'Template selection', 700, 500);return false;");

        btnOK.Text = ResHelper.GetString("PageProperties.OK");

        ltlScript.Text = "";

        int selectedTemplateId = 0;

        //define GetCurrentTemplateId() used for specifing teplateId in the SaveAsNewTemplate onClick handler
        string initScript = "";
        initScript += "function GetCurrentTemplateId() \n";
        initScript += "{ \n";
        initScript += "if (document.getElementById('SelectedTemplateId').value > 0) \n";
        initScript += "{ \n";
        initScript += "return document.getElementById('SelectedTemplateId').value; \n";
        initScript += "} \n";
        initScript += "else \n";
        initScript += "{ \n";
        initScript += "return document.getElementById('InheritedTemplateId').value; \n";
        initScript += "} \n";
        initScript += "} \n";
        ltlPreInitScript.Text = ScriptHelper.GetScript(initScript);

        if (!IsPostBack)
        {
            // functions that are visible for global administrator
            if (CMSContext.CurrentUser.IsGlobalAdministrator)
            {
                btnSave.Visible = true;
                btnClone.Visible = true;
                btnEditTemplateProperties.Visible = true;
            }
            else
            {
                // functions that are visible for other users
                btnSave.Visible = false;
                btnClone.Visible = false;
                btnEditTemplateProperties.Visible = false;
            }
            selectedTemplateId = ReloadData();
            /*if (node != null)
            {
                if (node.GetValue("DocumentPageTemplateID") == null)
                {
                    //if template is inherited
                    btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('InheritedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
                }
                else 
                {
                    //if template is not inherited
                    btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('SelectedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
                }
            }*/
            btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateId=' + GetCurrentTemplateId() + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";

            if (node != null)
            {
                if (node.NodeAliasPath != "/")
                {
                    this.InheritLevels1.SelectedLevels = node.NodeInheritPageLevels;
                    this.InheritLevels1.TreePath = TreePathUtils.GetParentPath(node.DocumentNamePath);
                }
                else
                {
                    plcInherits.Visible = false;
                }
            }
        }
        else
        {
            selectedTemplateId = ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0);
            initScript = "";
            initScript += "document.getElementById('SelectedTemplateId').value = " + ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0).ToString() + "; \n ";
            initScript += "document.getElementById('InheritedTemplateId').value = " + ValidationHelper.GetInteger(Request.Params["InheritedTemplateId"], 0).ToString() + "; \n ";
            initScript += "document.getElementById('Saved').value = " + ValidationHelper.GetBoolean(Request.Params["Saved"], false).ToString().ToLower() + "; \n";
            initScript += "document.getElementById('TemplateDisplayName').value = '" + ValidationHelper.GetString(Request.Params["TemplateDisplayName"], "") + "'; \n ";
            initScript += "document.getElementById('TemplateDescription').value = '" + ValidationHelper.GetString(Request.Params["TemplateDescription"], "") + "'; \n ";
            initScript += "document.getElementById('TemplateCategory').value = '" + ValidationHelper.GetString(Request.Params["TemplateCategory"], "") + "'; \n ";
            initScript += "document.getElementById('isPortal').value = " + ValidationHelper.GetBoolean(Request.Params["isPortal"], false).ToString().ToLower() + "; \n ";
            initScript += "document.getElementById('isReusable').value = " + ValidationHelper.GetBoolean(Request.Params["isReusable"], false).ToString().ToLower() + "; \n ";
            initScript += "document.getElementById('isAdHoc').value = " + ValidationHelper.GetBoolean(Request.Params["isAdHoc"], false).ToString().ToLower() + "; \n ";
            if (ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0) == 0)
            {
                //initScript += "hideInherit(); \n";
            }
            string textTemplate = ValidationHelper.GetString(Request.Params["txtTemplate"], "");
            if (textTemplate == "")
            {
                textTemplate = ValidationHelper.GetString(Request.Params["TextTemplate"], "");
            }
            initScript += "document.getElementById('TextTemplate').value = '" + textTemplate.Replace("'", "\\'") + "'; \n ";

            ltlInitScript.Text = ScriptHelper.GetScript(initScript);
            ltlScript.Text += ScriptHelper.GetScript("ShowButtons(document.getElementById('isPortal').value, document.getElementById('isReusable').value, document.getElementById('isAdHoc').value); \n");
            /*if ((node == null) || (node.GetValue("DocumentPageTemplateID") == null))
            {*/
            //if template is inherited then hide the inherit button
            ltlScript.Text += ScriptHelper.GetScript("if (document.getElementById('SelectedTemplateId').value == 0) { if (inheritElemStyle != null) inheritElemStyle.display = 'none'; if (editTemplatePropertiesElemStyle != null) editTemplatePropertiesElemStyle.display = 'none'; }");
            /*}*/
            txtTemplate.Text = textTemplate;
            /*if (ValidationHelper.GetInteger(Request.Params["InheritedTemplateId"], 0) != 0)
            {
                //if template is inherited
                btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('InheritedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
            }
            else if (ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0) != 0)
            {
                //if template is not inherited
                btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('SelectedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
            }*/
            btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateId=' + GetCurrentTemplateId() + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
        }
    }


    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (hasModifyPermission)
        {
            this.pnlSoftTemplate.Enabled = this.menuElem.AllowEdit;
        }
        this.lblWorkflowInfo.Text = this.menuElem.WorkflowInfo;
        this.lblWorkflowInfo.Visible = (this.lblWorkflowInfo.Text != "");
        btnSave.Attributes.Add("onclick", btnSaveOnClickScript);
    }


    private int ReloadData()
    {
        int result = 0;
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        if (node != null)
        {
            // Check read permissions
            if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Read) == AuthorizationResultEnum.Denied)
            {
                CMSDeskPage.RedirectToAccessDenied(String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoreaddocument"), node.NodeAliasPath));
            }
            // Check modify permissions
            else if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Modify) == AuthorizationResultEnum.Denied)
            {
                hasModifyPermission = false;
                this.pnlSoftTemplate.Enabled = false;
                this.lblWorkflowInfo.Text = String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoeditdocument"), node.NodeAliasPath);
            }


            // show tmplate name by template id
            if (node.GetValue("DocumentPageTemplateID") != null)
            {
                PageTemplateInfo pt = new PageTemplateInfo();
                pt = PageTemplateInfoProvider.GetPageTemplateInfo(Convert.ToInt32(node.GetValue("DocumentPageTemplateID")));
                if (pt != null)
                {
                    //this.txtTemplate.Text = pt.DisplayName;
                    bool isAdHoc = false;
                    if ((pt.DisplayName.Length > 5) && (pt.DisplayName.Substring(0, 6) == "ad-hoc")) isAdHoc = true;
                    ltlScript.Text += ScriptHelper.GetScript("SelectTemplate(" + pt.PageTemplateId + ", '" + pt.DisplayName.Replace("'", "\\'") + "'); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", " + isAdHoc.ToString().ToLower() + "); RememberTemplate('" + pt.DisplayName.Replace("'", "\\'") + "');");
                    result = pt.PageTemplateId;
                }
                else
                {
                    ltlScript.Text += ScriptHelper.GetScript("NoTemplateSelected();");
                }
                btnInherit.Visible = true;
            }
            else
            {
                btnInherit_Click(null, null);
            }
        }

        return result;
    }


    /// <summary>
    /// Updates node properties in database
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        //tree.SelectSingleNode(nodeId);
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        if (node != null)
        {
            bool autoCheck = !VersionManager.UseCheckInCheckOut(CMSContext.CurrentSite.SiteName);
            VersionManager vm = null;
            bool useWorkflow = false;
            WorkflowManager workflowMan = new WorkflowManager();

            // Get the document
            node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

            //test if the document uses workflow
            if (workflowMan.GetNodeWorkflowScope(node) != null)
            {
                useWorkflow = true;
            }

            // If not using check-in/check-out, check out automatically
            if (autoCheck & useWorkflow)
            {
                if (node != null)
                {
                    // Check out
                    vm = new VersionManager(tree);
                    vm.CheckOut(node);

                }
            }

            // Update the data

            // update DocumentPageTemplateID and txtTemplate.Text
            
            int selectedPageTemplateId = ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0);

            // Save just created ad-hoc template
            if (cloneId > 0)
            {
                selectedPageTemplateId = cloneId;
            }

            if (selectedPageTemplateId != 0)
            {
                ltlScript.Text += ScriptHelper.GetScript("document.getElementById('SelectedTemplateId').value = " + selectedPageTemplateId.ToString());
                if ((txtTemplate.Text.Length > 5) && (txtTemplate.Text.Substring(0, 6) == "ad-hoc"))
                {
                    // ad-hoc page is used, set ad-hoc page as DocumentPageTemplateID
                    node.SetValue("DocumentPageTemplateID", selectedPageTemplateId);

                    PageTemplateInfo pt = PageTemplateInfoProvider.GetPageTemplateInfo(selectedPageTemplateId);
                    if (pt != null)
                    {
                        ltlScript.Text += ScriptHelper.GetScript("pressedClone(" + selectedPageTemplateId + ",null); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", true)");
                    }
                }
                else
                {
                    // template was selected, set SelectedTemplateId as DocumentPageTemplateID
                    PageTemplateInfo pt = PageTemplateInfoProvider.GetPageTemplateInfo(selectedPageTemplateId);
                    if (pt != null)
                    {
                        node.SetValue("DocumentPageTemplateID", ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0));
                        ltlScript.Text += ScriptHelper.GetScript("SelectTemplate(" + selectedPageTemplateId + ",null); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", false)");
                    }
                }
            }
            else
            {
                // template is inherited, set null as DocumentPageTemplateID
                node.SetValue("DocumentPageTemplateID", null);
                int inheritedTemplateID = ValidationHelper.GetInteger(Request.Params["InheritedTemplateId"], 0);
                if (inheritedTemplateID > 0)
                {
                    PageTemplateInfo pt = PageTemplateInfoProvider.GetPageTemplateInfo(inheritedTemplateID);
                    if (pt != null)
                    {
                        ltlScript.Text += ScriptHelper.GetScript("pressedInherit(" + inheritedTemplateID + "); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", false)");
                    }
                }
                else
                {
                    node.SetValue("DocumentPageTemplateID", null);
                    ltlScript.Text += ScriptHelper.GetScript("pressedInherit(0); ShowButtons(false, false, false); ");
                }
            }

            node.SetValue("NodeInheritPageLevels", this.InheritLevels1.SelectedLevels);

            DocumentHelper.UpdateDocument(node, tree);

            // Check in the document
            if (autoCheck & useWorkflow)
            {
                vm.CheckIn(node, null, null);
            }

            this.menuElem.ReloadMenu();
            
            lblInfo.Visible = true;
            lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
            //Response.Redirect("page.aspx");
        }
    }


    protected void btnInherit_Click(object sender, EventArgs e)
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        int pageTemplateId = 0;
        if ((node != null) && (node.NodeParentID > 0))
        {
            CMS.TreeEngine.TreeNode parent = DocumentHelper.GetDocument(node.NodeParentID, CMSContext.CurrentUser.PreferredCultureCode, tree);
            if (parent != null)
            {
                while (parent != null)
                {
                    if (parent.DocumentPageTemplateID > 0)
                    {
                        pageTemplateId = parent.DocumentPageTemplateID;
                        break;
                    }
                    parent = DocumentHelper.GetDocument(parent.NodeParentID, CMSContext.CurrentUser.PreferredCultureCode, tree);
                }
            }
        }
        
        if (pageTemplateId > 0)
        {
            PageTemplateInfo pt = new PageTemplateInfo();
            pt = PageTemplateInfoProvider.GetPageTemplateInfo(pageTemplateId);
            if (pt != null)
            {
                this.txtTemplate.Text = pt.DisplayName + " (inherited)";
                ltlScript.Text += ScriptHelper.GetScript("pressedInherit(" + pageTemplateId + "); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", false);");
                btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('InheritedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
            }
        }
        else
        {
            this.txtTemplate.Text = "";
            ltlScript.Text += ScriptHelper.GetScript("pressedInherit(" + pageTemplateId + "); ShowButtons(false, false, false); ");
        }

    }


    protected void btnClone_Click(object sender, EventArgs e)
    {
        int pageTemplateId = ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0);
        if (pageTemplateId == 0) pageTemplateId = ValidationHelper.GetInteger(Request.Params["InheritedTemplateId"], 0);
        if (pageTemplateId > 0)
        {
            PageTemplateInfo pt = PageTemplateInfoProvider.GetPageTemplateInfo(pageTemplateId);
            if (pt != null)
            {
                // Clone the info
                PageTemplateInfo newInfo = PageTemplateInfoProvider.CloneTemplateAsAdHoc(pt);
                newInfo.Description = String.Format(ResHelper.GetString("PageTemplate.AdHocDescription"), node.DocumentNamePath);
                PageTemplateInfoProvider.SetPageTemplateInfo(newInfo);

                ltlScript.Text += ScriptHelper.GetScript("pressedClone(" + newInfo.PageTemplateId.ToString() + "); ShowButtons(" + pt.IsPortal.ToString().ToLower() + ", " + pt.IsReusable.ToString().ToLower() + ", true);");
                btnSaveOnClickScript = "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('SelectedTemplateId').value + '&siteid=" + siteid + "', 'Save new template', 470, 360);return false;";
                txtTemplate.Text = newInfo.DisplayName;

                cloneId = newInfo.PageTemplateId;

                if (CMSContext.CurrentSite != null)
                {
                    PageTemplateInfoProvider.AddPageTemplateToSite(newInfo.PageTemplateId, CMSContext.CurrentSite.SiteID);
                }
            }
            btnSave.Visible = true;

            btnOK_Click(sender, e);
        }
    }

    #region "Callback handling"

    /// <summary>
    /// Current template description
    /// </summary>
    private int cbResultFlags = -1; // -1 = (false,...,false), 0 = (true,false,false), 1 = (true,true,false)
    //isAdhoc: 2 = (false,...,true),  3 = (true,false,true),  4 = (true,true,true)


    /// <summary>
    /// Callback event handler
    /// </summary>
    /// <param name="argument">Callback argument</param>
    public void RaiseCallbackEvent(string argument)
    {
        int pageTemplateId = 0;
        pageTemplateId = Convert.ToInt32(argument);
        if (pageTemplateId > 0)
        {
            PageTemplateInfo pt = PageTemplateInfoProvider.GetPageTemplateInfo(pageTemplateId);
            if (pt != null)
            {
                if ((pt.IsPortal) && (pt.IsReusable))
                {
                    cbResultFlags = 1;
                }
                else if ((pt.IsPortal) && (!pt.IsReusable))
                {
                    cbResultFlags = 0;
                }
                else
                {
                    cbResultFlags = -1;
                }
                if ((pt.DisplayName.Length > 5) && (pt.DisplayName.Substring(0, 6) == "ad-hoc")) cbResultFlags += 3;
            }
        }
    }


    /// <summary>
    /// Callback result retrieving handler
    /// </summary>
    public string GetCallbackResult()
    {
        return cbResultFlags.ToString();
    }

    #endregion



}


/*

           selectedTemplateId = ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0);
            string initScript = "";
            initScript = "";
            initScript += "var SelectedTemplateId = " + ValidationHelper.GetInteger(Request.Params["SelectedTemplateId"], 0).ToString() + "; \n ";
            initScript += "var InheritedTemplateId = " + ValidationHelper.GetInteger(Request.Params["InheritedTemplateId"], 0).ToString() + "; \n ";
            initScript += "var SelectedLayoutId = " + ValidationHelper.GetInteger(Request.Params["SelectedLayoutId"], 0).ToString() + "; \n ";
            initScript += "var Saved = " + ValidationHelper.GetBoolean(Request.Params["Saved"], false).ToString().ToLower() + "; \n";
            initScript += "var TemplateDisplayName = '" + ValidationHelper.GetString(Request.Params["TemplateDisplayName"], "") + "'; \n ";
            initScript += "var TemplateDescription = '" + ValidationHelper.GetString(Request.Params["TemplateDescription"], "") + "'; \n ";
            initScript += "var TemplateCategory = '" + ValidationHelper.GetString(Request.Params["TemplateCategory"], "") + "'; \n ";
            initScript += "var gIsPortal = '" + ValidationHelper.GetBoolean(Request.Params["XisPortal"], false).ToString().ToLower() + "'; \n ";
            initScript += "var gIsReusable = '" + ValidationHelper.GetBoolean(Request.Params["isReusable"], false).ToString().ToLower() + "'; \n ";
            initScript += "var gIsAdHoc = '" + ValidationHelper.GetBoolean(Request.Params["isAdHoc"], false).ToString().ToLower() + "'; \n ";
            string textTemplate = ValidationHelper.GetString(Request.Params["txtTemplate"], "");
            if (textTemplate == "")
            {
                textTemplate = ValidationHelper.GetString(Request.Params["TextTemplate"], "");
            }
            initScript += "var TextTemplate = '" + textTemplate + "'; \n ";
            ltlInitScript.Text = ScriptHelper.GetScript(initScript);
            txtTemplate.Text = textTemplate;
            
            initScript = "";
            initScript += "document.getElementById('SelectedTemplateId').value = SelectedTemplateId; \n ";
            initScript += "document.getElementById('InheritedTemplateId').value = InheritedTemplateId; \n ";
            initScript += "document.getElementById('SelectedLayoutId').value = SelectedLayoutId; \n ";
            initScript += "document.getElementById('Saved').value = Saved; \n ";
            initScript += "document.getElementById('TemplateDisplayName').value = TemplateDisplayName; \n ";
            initScript += "document.getElementById('TemplateDescription').value = TemplateDescription; \n ";
            initScript += "document.getElementById('TemplateCategory').value = TemplateCategory; \n ";
            initScript += "document.getElementById('TextTemplate').value = TextTemplate; \n ";
            initScript += "ShowButtons(gIsPortal, gIsReusable, gIsAdHoc);";
            initScript += "document.getElementById('isPortal').value = gIsPortal; \n ";
            initScript += "document.getElementById('isReusable').value = gIsReusable; \n ";
            initScript += "document.getElementById('isAdHoc').value = gIsAdHoc; \n ";
            ltlScript.Text = ScriptHelper.GetScript(initScript);
        }
        btnSave.Attributes.Add("onclick", "modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SaveNewPageTemplate.aspx") + "?templateid=' + document.getElementById('SelectedTemplateId').value + '&siteid=' + " + siteid + ", 'Save new template', 470, 360);return false;");

*/