using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.SiteProvider;

public partial class CMSDesk_Content_listing : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.titleElem.TitleText = ResHelper.GetString("Content.ListingTitle");
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/listing.gif";

        this.imgParent.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/parent.gif";
        this.lnkParent.Text = ResHelper.GetString("Listing.ParentDirectory");

        this.gridDocuments.GridView.PageSize = 20;

        this.gridDocuments.GridView.GridLines = GridLines.Horizontal;
        this.gridDocuments.OnExternalDataBound += new OnExternalDataBoundEventHandler(gridDocuments_OnExternalDataBound);

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }

        if (nodeId > 0)
        {
            TreeProvider tree =  new TreeProvider();
            CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);
            if (node != null)
            {
                SiteInfo si = SiteInfoProvider.GetSiteInfo(node.NodeSiteID);
                if (si != null)
                {
                    DataSet nodes = tree.SelectNodes(si.SiteName, node.NodeAliasPath.TrimEnd('/') + "/%", TreeProvider.ALL_CULTURES, true, null, "NodeAliasPath <> '/'", "NodeOrder ASC, NodeName ASC, NodeAlias ASC", 1, false);
                    this.gridDocuments.DataSource = nodes;
                }

                if (node.NodeParentID > 0)
                {
                    this.lnkParent.NavigateUrl = "javascript:SelectItem(" + node.NodeParentID + ");";
                }
                else
                {
                    this.pnlParent.Visible = false;
                }
            }
        }
    }


    /// <summary>
    /// External data binding handler
    /// </summary>
    object gridDocuments_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        switch (sourceName.ToLower())
        {
            case "published":
                bool published = ValidationHelper.GetBoolean(parameter, true);
                if ( published )
                {
                    return "<span class=\"DocumentPublishedYes\">" + ResHelper.GetString("General.Yes") + "</span>";
                }
                else
                {
                    return "<span class=\"DocumentPublishedNo\">" + ResHelper.GetString("General.No") + "</span>";
                }
            //break;
        }
        return parameter;
    }

}
