using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.LicenseProvider;

public partial class CMSDesk_Default : CMSDeskPage
{
    protected string desktoppage;
    protected string trialHeight;
    protected string trialExpires;

    protected void Page_Load(object sender, EventArgs e)
    {        
        if (DataHelper.GetNotEmpty(UrlHelper.GetCurrentDomain(), "") != "")
        {
            LicenseKeyInfo lki = LicenseKeyInfoProvider.GetLicenseKeyInfo(UrlHelper.GetCurrentDomain());
            if ((lki != null) && (lki.Key.Length == LicenseKeyInfo.TRIAL_KEY_LENGTH) && (lki.ExpirationDate != LicenseKeyInfo.TIME_UNLIMITED_LICENSE))
            {
                trialHeight = "17";
                trialExpires = "?expirationdate=" + lki.ExpirationDate.Subtract(DateTime.Now).Days;
            }
            else
            {
                trialHeight = "0";
                trialExpires = "";
            }
        }

        string section = ValidationHelper.GetString(Request.QueryString["section"], "content").ToLower();
        switch (section)
        {
            case "content":
                if (!IsUserAuthorizedPerContent())
                {
                    desktoppage = "MyDesk/default.aspx";
                }
                else
                {
                    desktoppage = "Content/default.aspx";
                }
                break;

            case "mydesk":
                desktoppage = "MyDesk/default.aspx";
                break;

            case "tools":
                if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.tools", "Open"))
                {
                    desktoppage = "MyDesk/default.aspx";
                }
                else
                {
                    desktoppage = "Tools/default.aspx";
                }
                break;

            case "administration":
                if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.administration", "Read"))
                {
                    desktoppage = "MyDesk/default.aspx";
                }
                else
                {
                    desktoppage = "Administration/default.aspx";
                }
                break;
        }


        desktoppage += Request.Url.Query;
    }
}
