using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.FormEngine;
using CMS.DataEngine;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_BizForms_BizForm_Edit_NewRecord : CMSDeskPage
{
    protected int formId = 0;
    protected int formRecordId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'ReadData' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "ReadData"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.form", "ReadData");
        }
        // check 'EditData' permission
        else if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "EditData"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.form", "EditData");
        }

        string[,] pageTitleTabs = new string[2, 3];
        string currentRecord = "";
        BizFormInfo bfi = null;

        // get form id
        formId = ValidationHelper.GetInteger(Request.QueryString["formid"], 0);
        // get form record id
        formRecordId = ValidationHelper.GetInteger(Request.QueryString["formrecordid"], 0);

        // edit record
        if (formRecordId > 0)
        {
            currentRecord = ResHelper.GetString("BizForm_Edit_EditRecord.EditRecord");
        }
        // new record
        else
        {
            currentRecord = ResHelper.GetString("BizForm_Edit_EditRecord.NewRecord");
        }

        // initializes page title
        pageTitleTabs[0, 0] = ResHelper.GetString("BizForm_Edit_EditRecord.Data");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/BizForms/BizForm_Edit_Data.aspx?formid=" + formId;
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = currentRecord;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        titleElem.Breadcrumbs = pageTitleTabs;

        if (!Page.IsPostBack)
        {
            // get form info
            bfi = BizFormInfoProvider.GetBizFormInfo(formId);

            if (bfi != null)
            {                
                // set form
                BizFormNew.FormName = bfi.FormName;
                BizFormNew.ItemID = formRecordId;
                BizFormNew.ShowPrivateFields = true;
            }
        }
    }


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        BizFormNew.BasicForm.SubmitButton.CssClass = "ContentButton";
    }

}
