CREATE TABLE [CMS_CssStylesheet] (
		[StylesheetID]                        int NOT NULL IDENTITY(1, 1),
		[StylesheetDisplayName]               nvarchar(200) NOT NULL,
		[StylesheetName]                      nvarchar(200) NOT NULL,
		[StylesheetText]                      ntext NOT NULL,
		[StylesheetCheckedOutByUserID]        int NULL,
		[StylesheetCheckedOutMachineName]     nvarchar(100) NULL,
		[StylesheetCheckedOutFileName]        nvarchar(450) NULL,
		[StylesheetVersionGUID]               nvarchar(50) NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_CssStylesheet]
	ADD
	CONSTRAINT [PK__CMS_CssStyleshee__7C8480AE]
	PRIMARY KEY
	([StylesheetID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_CssStylesheet]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_CssStylesheet_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [CMS_CssStylesheet]
			ADD CONSTRAINT [FK_CMS_CssStylesheet_CMS_User]
			FOREIGN KEY ([StylesheetCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID])
END
CREATE INDEX [IX_CMS_CssStylesheet]
	ON [CMS_CssStylesheet] ([StylesheetName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_CssStylesheet_1]
	ON [CMS_CssStylesheet] ([StylesheetDisplayName])
	ON [PRIMARY]
