CREATE TABLE [CMS_Layout] (
		[LayoutID]                        int NOT NULL IDENTITY(1, 1),
		[LayoutCodeName]                  nvarchar(100) NOT NULL,
		[LayoutDisplayName]               nvarchar(200) NOT NULL,
		[LayoutDescription]               ntext NOT NULL,
		[LayoutCode]                      ntext NOT NULL,
		[LayoutCheckedOutFilename]        nvarchar(450) NULL,
		[LayoutCheckedOutByUserID]        int NULL,
		[LayoutCheckedOutMachineName]     nvarchar(50) NULL,
		[LayoutVersionGUID]               nvarchar(50) NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_Layout]
	ADD
	CONSTRAINT [PK__CMS_Layout__2A4B4B5E]
	PRIMARY KEY
	([LayoutID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_Layout]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Layout_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [CMS_Layout]
			ADD CONSTRAINT [FK_CMS_Layout_CMS_User]
			FOREIGN KEY ([LayoutCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID])
END
CREATE INDEX [IX_CMS_Layout]
	ON [CMS_Layout] ([LayoutCodeName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Layout_1]
	ON [CMS_Layout] ([LayoutDisplayName])
	ON [PRIMARY]
