CREATE TABLE [COM_SKU] (
		[SKUID]                   int NOT NULL IDENTITY(1, 1),
		[SKUNumber]               nvarchar(200) NULL,
		[SKUName]                 nvarchar(200) NOT NULL,
		[SKUDescription]          ntext NULL,
		[SKUPrice]                float NOT NULL,
		[SKUEnabled]              bit NOT NULL,
		[SKUDepartmentID]         int NOT NULL,
		[SKUManufacturerID]       int NULL,
		[SKUInternalStatusID]     int NULL,
		[SKUPublicStatusID]       int NULL,
		[SKUSupplierID]           int NULL,
		[SKUAvailableInDays]      int NULL,
		[SKUGUID]                 uniqueidentifier NOT NULL,
		[SKUImagePath]            nvarchar(450) NULL,
		[SKUWeight]               float NULL,
		[SKUWidth]                float NULL,
		[SKUDepth]                float NULL,
		[SKUHeight]               float NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [COM_SKU]
	ADD
	CONSTRAINT [PK_COM_SKU]
	PRIMARY KEY
	([SKUID])
	ON [PRIMARY]
IF OBJECT_ID(N'[COM_SKU]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Department]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_SKU_COM_Department]') IS NULL
BEGIN
		ALTER TABLE [COM_SKU]
			ADD CONSTRAINT [FK_COM_SKU_COM_Department]
			FOREIGN KEY ([SKUDepartmentID]) REFERENCES [COM_Department] ([DepartmentID])
END
IF OBJECT_ID(N'[COM_SKU]') IS NOT NULL
	AND OBJECT_ID(N'[COM_InternalStatus]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_SKU_COM_InternalStatus]') IS NULL
BEGIN
		ALTER TABLE [COM_SKU]
			ADD CONSTRAINT [FK_COM_SKU_COM_InternalStatus]
			FOREIGN KEY ([SKUInternalStatusID]) REFERENCES [COM_InternalStatus] ([InternalStatusID])
END
IF OBJECT_ID(N'[COM_SKU]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Manufacturer]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_SKU_COM_Manifacturer]') IS NULL
BEGIN
		ALTER TABLE [COM_SKU]
			ADD CONSTRAINT [FK_COM_SKU_COM_Manifacturer]
			FOREIGN KEY ([SKUManufacturerID]) REFERENCES [COM_Manufacturer] ([ManufacturerID])
END
IF OBJECT_ID(N'[COM_SKU]') IS NOT NULL
	AND OBJECT_ID(N'[COM_PublicStatus]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_SKU_COM_PublicStatus]') IS NULL
BEGIN
		ALTER TABLE [COM_SKU]
			ADD CONSTRAINT [FK_COM_SKU_COM_PublicStatus]
			FOREIGN KEY ([SKUPublicStatusID]) REFERENCES [COM_PublicStatus] ([PublicStatusID])
END
IF OBJECT_ID(N'[COM_SKU]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Supplier]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_SKU_COM_Supplier]') IS NULL
BEGIN
		ALTER TABLE [COM_SKU]
			ADD CONSTRAINT [FK_COM_SKU_COM_Supplier]
			FOREIGN KEY ([SKUSupplierID]) REFERENCES [COM_Supplier] ([SupplierID])
END
CREATE INDEX [IX_COM_SKU]
	ON [COM_SKU] ([SKUPrice])
	ON [PRIMARY]
CREATE INDEX [IX_COM_SKU_1]
	ON [COM_SKU] ([SKUNumber])
	ON [PRIMARY]
CREATE INDEX [IX_COM_SKU_2]
	ON [COM_SKU] ([SKUName])
	ON [PRIMARY]
