CREATE TABLE [Newsletter_Emails] (
		[EmailID]                    int NOT NULL IDENTITY(1, 1),
		[EmailNewsletterIssueID]     int NOT NULL,
		[EmailSubscriberID]          int NOT NULL,
		[EmailText]                  ntext NOT NULL,
		[EmailSubject]               nvarchar(500) NOT NULL,
		[ErrorMessage]               ntext NOT NULL,
		[EmailLastSendAttempt]       datetime NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [Newsletter_Emails]
	ADD
	CONSTRAINT [PK__Newsletter_Email__3D2915A8]
	PRIMARY KEY
	([EmailID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Newsletter_Emails]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_NewsletterIssue]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Newsletter_Emails_Newsletter_NewsletterIssue]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Emails]
			ADD CONSTRAINT [FK_Newsletter_Emails_Newsletter_NewsletterIssue]
			FOREIGN KEY ([EmailNewsletterIssueID]) REFERENCES [Newsletter_NewsletterIssue] ([IssueID])
END
IF OBJECT_ID(N'[Newsletter_Emails]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_Subscriber]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Newsletter_Emails_Newsletter_Subscriber]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Emails]
			ADD CONSTRAINT [FK_Newsletter_Emails_Newsletter_Subscriber]
			FOREIGN KEY ([EmailSubscriberID]) REFERENCES [Newsletter_Subscriber] ([SubscriberID])
END
CREATE INDEX [IX_Newsletter_Emails]
	ON [Newsletter_Emails] ([EmailNewsletterIssueID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Emails_1]
	ON [Newsletter_Emails] ([EmailSubscriberID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Emails_2]
	ON [Newsletter_Emails] ([EmailLastSendAttempt])
	ON [PRIMARY]
