CREATE PROCEDURE [Proc_CMS_Document_UpdateDocumentNamePath]
	@SiteID int,
	@StartingAliasPath nvarchar(450),
	@DefaultCultureCode nvarchar(10)
AS
BEGIN
	DECLARE @currentLevel int;
	DECLARE @nodesCount int;
	/* Init current level */
	SET @currentLevel = (SELECT TOP 1 NodeLevel FROM CMS_Tree WHERE NodeAliasPath = @StartingAliasPath AND NodeSiteID = @SiteID) + 1;
	SET @nodesCount = 1;
	/* Cycle through the child levels */
	WHILE @nodesCount > 0
	BEGIN	
		/* Update the paths */
		UPDATE CMS_Document SET DocumentNamePath = (SELECT TOP 1 DocumentNamePath FROM (
			(SELECT PathView.DocumentNamePath, 1 AS Priority FROM View_CMS_Tree_Joined PathView WHERE PathView.NodeID = (SELECT TOP 1 NodeParentID FROM CMS_Tree WHERE NodeID = CMS_Document.DocumentNodeID) AND PathView.DocumentCulture = CMS_Document.DocumentCulture) UNION 
			(SELECT PathView.DocumentNamePath, 2 AS Priority FROM View_CMS_Tree_Joined PathView WHERE PathView.NodeID = (SELECT TOP 1 NodeParentID FROM CMS_Tree WHERE NodeID = CMS_Document.DocumentNodeID) AND PathView.DocumentCulture = @DefaultCultureCode) UNION
			(SELECT PathView.DocumentNamePath, 3 AS Priority FROM View_CMS_Tree_Joined PathView WHERE PathView.NodeID = (SELECT TOP 1 NodeParentID FROM CMS_Tree WHERE NodeID = CMS_Document.DocumentNodeID))
		) ParentPaths ORDER BY Priority ASC) + '/' + DocumentName
		WHERE DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeAliasPath LIKE @StartingAliasPath + '/%' AND NodeSiteID = @SiteID AND NodeLevel = @currentLevel)
		/* Move to the next level */
		SET @currentLevel = @currentLevel + 1;
		/* Update nodes count */
		SET @nodesCount = (SELECT COUNT(*) FROM CMS_Tree WHERE NodeAliasPath LIKE @StartingAliasPath + '/%' AND NodeSiteID = @SiteID AND NodeLevel = @currentLevel)
	END;
END
