CREATE TABLE [Staging_Synchronization] (
		[SynchronizationID]               int NOT NULL IDENTITY(1, 1),
		[SynchronizationTaskID]           int NOT NULL,
		[SynchronizationServerID]         int NOT NULL,
		[SynchronizationLastRun]          datetime NULL,
		[SynchronizationErrorMessage]     ntext NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [Staging_Synchronization]
	ADD
	CONSTRAINT [PK_Staging_Synchronization]
	PRIMARY KEY
	([SynchronizationID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Staging_Synchronization]') IS NOT NULL
	AND OBJECT_ID(N'[Staging_Server]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Staging_Synchronization_Staging_Server]') IS NULL
BEGIN
		ALTER TABLE [Staging_Synchronization]
			ADD CONSTRAINT [FK_Staging_Synchronization_Staging_Server]
			FOREIGN KEY ([SynchronizationServerID]) REFERENCES [Staging_Server] ([ServerID])
END
IF OBJECT_ID(N'[Staging_Synchronization]') IS NOT NULL
	AND OBJECT_ID(N'[Staging_Task]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Staging_Synchronization_Staging_Task]') IS NULL
BEGIN
		ALTER TABLE [Staging_Synchronization]
			ADD CONSTRAINT [FK_Staging_Synchronization_Staging_Task]
			FOREIGN KEY ([SynchronizationTaskID]) REFERENCES [Staging_Task] ([TaskID])
END
