using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


using CMS.SiteProvider;
using CMS.GlobalHelper;

public partial class CMSSiteManager_Development_CssStylesheets_CssStylesheet_New : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        lblCssStylesheetDisplayName.Text = ResHelper.GetString("CssStylesheet_General.DisplayName");
        lblCssStylesheetName.Text = ResHelper.GetString("CssStylesheet_General.Name");
        lblCssStylesheetText.Text = ResHelper.GetString("CssStylesheet_General.Text");

        btnOK.Text = ResHelper.GetString("CssStylesheet_General.OK");

        rfvDisplayName.ErrorMessage = ResHelper.GetString("CssStylesheet_New.EmptyDisplayName");
        rfvName.ErrorMessage = ResHelper.GetString("CssStylesheet_New.EmptyName");
        rfvText.ErrorMessage = ResHelper.GetString("CssStylesheet_New.EmptyText");

        string cssStylesheets = ResHelper.GetString("CssStylesheet.CssStylesheets");
        string currentCssStylesheet = ResHelper.GetString("CssStylesheet.NewCssStylesheet");
        string title = ResHelper.GetString("CssStylesheet.TitleNew");

        string cssStylesheetUrl = "~/CMSSiteManager/Development/CssStylesheets/CssStylesheet_List.aspx";

        // initializes page title
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = cssStylesheets;
        pageTitleTabs[0, 1] = cssStylesheetUrl;
        pageTitleTabs[0, 2] = "devmain";
        pageTitleTabs[1, 0] = currentCssStylesheet;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitleNew.Breadcrumbs = pageTitleTabs;
        PageTitleNew.TitleText = title;
        PageTitleNew.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/CssStylesheets/newstylesheet.gif";

    }

    protected void btnOK_Click(object sender, EventArgs e)
    {
        // finds whether required fields are not empty
        string result = new Validator().NotEmpty(txtDisplayName.Text, ResHelper.GetString("CssStylesheet_New.EmptyDisplayName")).NotEmpty(txtName.Text, ResHelper.GetString("CssStylesheet_New.EmptyName")).NotEmpty(txtText.Text, ResHelper.GetString("CssStylesheet_New.EmptyText")).Result;

        if (result == "")
        {
            try
            {
                int cssStylesheetId = SaveNewCssStylesheet();

                if (cssStylesheetId > 0)
                {
                    Response.Redirect("CssStylesheet_Edit.aspx?cssstylesheetid=" + cssStylesheetId + "&saved=1");
                }
            }
            catch (Exception ex)
            {
                lblError.Visible = true;
                lblError.Text = ex.Message.Replace("%%name%%",txtName.Text);
            }
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = result;
        }
    }

    protected int SaveNewCssStylesheet()
    {
        CssStylesheetInfo cs = new CssStylesheetInfo();
        cs.StylesheetDisplayName = txtDisplayName.Text;
        cs.StylesheetName = txtName.Text;
        cs.StylesheetText = txtText.Text;
        CssStylesheetInfoProvider.SetCssStylesheetInfo(cs);
        return cs.StylesheetID;
    }
}
