using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.Controls;
using CMS.CMSHelper;

public partial class CMSWebParts_Viewers_ImageGallery : CMSAbstractWebPart
{
    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.CMSDataList1.CacheItemName), this.CMSDataList1.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.CMSDataList1.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.CMSDataList1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.CMSDataList1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSDataList1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSDataList1.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSDataList1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSDataList1.CultureCode), this.CMSDataList1.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSDataList1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSDataList1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSDataList1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSDataList1.OrderBy), this.CMSDataList1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSDataList1.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSDataList1.Path), this.CMSDataList1.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.CMSDataList1.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSDataList1.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.CMSDataList1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSDataList1.SiteName), this.CMSDataList1.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSDataList1.SiteName = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.CMSDataList1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSDataList1.WhereCondition = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.CMSDataList1.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.CMSDataList1.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.CMSDataList1.RelationshipName), this.CMSDataList1.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.CMSDataList1.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.CMSDataList1.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.CMSDataList1.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Thumbnail transformation
    /// </summary>
    public string ThumbnailTransformation
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ThumbnailTransformation"), this.CMSDataList1.TransformationName), this.CMSDataList1.TransformationName);
        }
        set
        {
            this.SetValue("ThumbnailTransformation", value);
            this.CMSDataList1.TransformationName = value;
        }
    }


    /// <summary>
    /// Detail transformation
    /// </summary>
    public string DetailTransformation
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("DetailTransformation"), this.CMSDataList1.SelectedItemTransformationName), this.CMSDataList1.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("DetailTransformation", value);
            this.CMSDataList1.SelectedItemTransformationName = value;
        }
    }


    #endregion


    #region "Pager properties"

    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.CMSDataList1.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.CMSDataList1.PagerControl.PagerPosition.ToString()));
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.CMSDataList1.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.CMSDataList1.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.CMSDataList1.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.CMSDataList1.PagerControl.QueryStringKey), this.CMSDataList1.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.CMSDataList1.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.CMSDataList1.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.CMSDataList1.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.CMSDataList1.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.CMSDataList1.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.CMSDataList1.PagerControl.ShowFirstLast = value;
        }
    }

    #endregion


    #region Public properties

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.CMSDataList1.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.CMSDataList1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.CMSDataList1.ZeroRowsText), this.CMSDataList1.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.CMSDataList1.ZeroRowsText = value;
        }
    }

    #endregion

    #region Repeat properties

    /// <summary>
    /// Number of columns to diplay
    /// </summary>
    public int Columns
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("Columns"), this.CMSDataList1.RepeatColumns);
        }
        set
        {
            this.SetValue("Columns", value);
            this.CMSDataList1.RepeatColumns = value;
            this.CMSDataList1.PagerControl.PageSize = value * this.RowsPerPage;
        }
    }

    /// <summary>
    /// Numbers of rows to display
    /// </summary>
    public int RowsPerPage
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("RowsPerPage"), 1);
        }
        set
        {
            this.SetValue("RowsPerPage", value);
            this.CMSDataList1.PagerControl.PageSize = this.Columns * value ;
        }
    }


    /// <summary>
    /// Repeat layout
    /// </summary>
    public RepeatLayout RepeatLayout
    {
        get
        {
            return CMSDataList.GetRepeatLayout(DataHelper.GetNotEmpty(this.GetValue("RepeatLayout"), this.CMSDataList1.RepeatLayout.ToString()));
        }
        set
        {
            this.SetValue("RepeatLayout", value);
            this.CMSDataList1.RepeatLayout = value;
        }
    }


    /// <summary>
    /// Repeat direction
    /// </summary>
    public RepeatDirection RepeatDirection
    {
        get
        {
            return CMSDataList.GetRepeatDirection(DataHelper.GetNotEmpty(this.GetValue("RepeatDirection"), this.CMSDataList1.RepeatDirection.ToString()));
        }
        set
        {
            this.SetValue("RepeatDirection", value);
            this.CMSDataList1.RepeatDirection = value;
        }
    }

    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || this.HideOnCurrentPage || (!this.IsVisible))
        {
            this.CMSDataList1.StopProcessing = true;
        }
        else
        {
            // Set properties from Webpart form   
            this.CMSDataList1.CacheItemName = this.CacheItemName;
            this.CMSDataList1.CacheMinutes = this.CacheMinutes;
            this.CMSDataList1.CheckPermissions = this.CheckPermissions;
            this.CMSDataList1.ClassNames = "cms.file";
            this.CMSDataList1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.CMSDataList1.CultureCode = this.CultureCode;
            this.CMSDataList1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSDataList1.OrderBy = this.OrderBy;
            this.CMSDataList1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSDataList1.SiteName = this.SiteName;
            this.CMSDataList1.WhereCondition = this.WhereCondition;
            
            // Relationships
            this.CMSDataList1.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
            this.CMSDataList1.RelationshipName = this.RelationshipName;
            this.CMSDataList1.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

            // Transformation properties
            this.CMSDataList1.TransformationName = this.ThumbnailTransformation;
            this.CMSDataList1.SelectedItemTransformationName = this.DetailTransformation;
            
            if (Request.QueryString["imagepath"] != null)
            {
                this.CMSDataList1.Path = Convert.ToString(Request.QueryString["imagepath"]);
                // Special for image gallery setting
                this.CMSDataList1.mProperties.IsAutomatic = true;
                this.CMSDataList1.ReloadData(true);
            }
            else
            {
                this.CMSDataList1.Path = this.Path;
            }

            // Pager properties
            this.CMSDataList1.PagerControl.PagerPosition = this.PagerPosition;
            this.CMSDataList1.EnablePaging = true;
            this.CMSDataList1.PagerControl.PageSize = this.Columns * this.RowsPerPage;
            this.CMSDataList1.PagerControl.QueryStringKey = this.QueryStringKey;
            this.CMSDataList1.PagerControl.PagingMode = this.PagingMode;
            this.CMSDataList1.PagerControl.ShowFirstLast = this.ShowFirstLast;

            // Repeat properties
            this.CMSDataList1.RepeatColumns = this.Columns;
            this.CMSDataList1.RepeatLayout = this.RepeatLayout;
            this.CMSDataList1.RepeatDirection = this.RepeatDirection;
            
            // Public properties
            this.CMSDataList1.HideControlForZeroRows = this.HideControlForZeroRows;
            this.CMSDataList1.ZeroRowsText = this.ZeroRowsText;
        }
    }


    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.CMSDataList1.ReloadData(true);
    }

}
