-- UPDATE TABLES

declare @indexexists int

set @indexexists = (SELECT count(name) FROM sysindexes WHERE name = 'IX_CMS_Document_12')
if @indexexists<>0
begin
	DROP INDEX CMS_Document.IX_CMS_Document_12
	ALTER TABLE [CMS_Document] ALTER COLUMN [DocumentCulture] nvarchar(10) NOT NULL
	CREATE NONCLUSTERED INDEX [IX_CMS_Document_12] ON [CMS_Document] ([DocumentCulture] ASC)
end

GO

-- INSERT CLASS
INSERT [CMS_Class] ([ClassDisplayName], [ClassName], [ClassUsesVersioning], [ClassIsDocumentType], [ClassIsCoupledClass], [ClassXmlSchema], [ClassFormDefinition], [ClassEditingPageUrl], [ClassListPageUrl], [ClassNodeNameSource], [ClassTableName], [ClassViewPageUrl], [ClassPreviewPageUrl], [ClassFormLayout], [ClassNewPageUrl], [ClassShowAsSystemTable], [ClassUsePublishFromTo], [ClassShowTemplateSelection], [ClassSKUMappings]) VALUES ('Ecommerce - Exchange rate', 'ecommerce.exchangerate', 0, 0, 1, '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="COM_CurrencyExchangeRate">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="ExchagneRateID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="ExchangeRateToCurrencyID" type="xs:int" />
              <xs:element name="ExchangeRateValue" type="xs:double" />
              <xs:element name="ExchangeTableID" type="xs:int" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//COM_CurrencyExchangeRate" />
      <xs:field xpath="ExchagneRateID" />
    </xs:unique>
  </xs:element>
</xs:schema>', '', '', '', '', 'COM_CurrencyExchangeRate', '', '', NULL, '', 0, NULL, NULL, NULL)

GO

-- UPDATE QUERIES

declare @classid int

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.attachmenthistory')
if @classid<>0
begin
	UPDATE [CMS_Query] SET [QueryText]='SELECT * FROM CMS_AttachmentHistory WHERE ##WHERE## AND AttachmentHistoryID IN (SELECT AttachmentHistoryID FROM CMS_VersionAttachment WHERE VersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE NodeSiteID=@SiteID OR @SiteID=0))' WHERE QueryName='selectAttachmentHistoryForExport' AND ClassID=@classid
	UPDATE [CMS_Query] SET [QueryText]='SELECT * FROM CMS_VersionAttachment WHERE ##WHERE## AND VersionHistoryID IN (SELECT VersionHistoryID FROM CMS_WorkFlowHistory WHERE StepID IN (SELECT StepID FROM CMS_WorkFlowStep WHERE StepWorkflowID IN (SELECT WorkFlowID FROM CMS_WorkFlow WHERE WorkFlowID IN (SELECT ScopeWorkFlowID FROM CMS_WorkFlowScope WHERE ScopeSiteID=@SiteID OR @SiteID=0))))' WHERE QueryName='selectVersionAttachmentForExport' AND ClassID=@classid
end

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.document')
if @classid<>0
begin
	UPDATE [CMS_Query] SET [QueryText]='SELECT ##TOPN## * FROM View_CMS_Tree_Joined WHERE ##WHERE## ORDER BY ##ORDERBY##' WHERE QueryName='selectdocuments' AND ClassID=@classid
end

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.workflowscope')
if @classid<>0
begin
	UPDATE [CMS_Query] SET [QueryText]='SELECT TOP 1 * FROM CMS_WorkflowScope WHERE ScopeSiteID = @ScopeSiteID AND ScopeClassID = @ScopeClassID AND (ScopeStartingPath = ''/'' OR @NodeAliasPath LIKE ScopeStartingPath + ''/%'' OR @NodeAliasPath LIKE ScopeStartingPath) ORDER BY ScopeStartingPath DESC' WHERE QueryName='getnodescope' AND ClassID=@classid
end

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='staging.task')
if @classid<>0
begin
	UPDATE [CMS_Query] SET [QueryText]='SELECT *, (SELECT COUNT(*) FROM Staging_Synchronization WHERE SynchronizationTaskID = TaskID AND SynchronizationErrorMessage IS NOT NULL AND (@ServerID = 0 OR SynchronizationServerID = @ServerID)) FailedCount FROM Staging_Task WHERE (TaskSiteID = @TaskSiteID) AND (@ServerID = 0 OR TaskID IN (SELECT SynchronizationTaskID FROM Staging_Synchronization WHERE SynchronizationServerID = @ServerID)) AND (##WHERE##) ORDER BY ##ORDERBY##' WHERE QueryName='selecttasklist' AND ClassID=@classid
end

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.state')
if @classid<>0
begin
	UPDATE [CMS_Query] SET [QueryText]='SELECT StateID FROM CMS_State WHERE (StateID IN (SELECT AddressStateID FROM COM_Address WHERE AddressStateID=@ID) OR StateID IN (SELECT CustomerStateID FROM COM_Customer WHERE CustomerStateID=@ID))' WHERE QueryName='CheckDependencies' AND ClassID=@classid
end

GO

-- INSERT QUERIES

declare @classid int

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='ecommerce.exchangerate')
if @classid<>0
begin
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('select', 0, 'SELECT * FROM COM_CurrencyExchangeRate WHERE [ExchagneRateID] = @ID', 0, @classid, 0)
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('delete', 0, 'DELETE FROM COM_CurrencyExchangeRate WHERE [ExchagneRateID] = @ID', 0, @classid, 0)
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('insert', 0, 'INSERT INTO COM_CurrencyExchangeRate ( [ExchangeRateToCurrencyID], [ExchangeRateValue], [ExchangeTableID] ) VALUES (  @ExchangeRateToCurrencyID, @ExchangeRateValue, @ExchangeTableID); SELECT @@identity AS [ExchagneRateID]', 1, @classid, 0)
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('update', 0, 'UPDATE COM_CurrencyExchangeRate SET  [ExchangeRateToCurrencyID] = @ExchangeRateToCurrencyID, [ExchangeRateValue] = @ExchangeRateValue, [ExchangeTableID] = @ExchangeTableID WHERE [ExchagneRateID] = @ExchagneRateID', 0, @classid, 0)
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('selectall', 0, 'SELECT * FROM COM_CurrencyExchangeRate WHERE ##WHERE## ORDER BY ##ORDERBY##', 0, @classid, 0)
end

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.tree')
if @classid<>0
begin
	INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('selectuniquenames', 0, 'SELECT DISTINCT NodeID, NodeAlias, NodeName FROM CMS_Tree WHERE NodeParentID=@NodeParentID AND (##WHERE##) ORDER BY (##ORDERBY##)', 0, @classid, 1)
end

GO

-- INSERT WEBPARTS

declare @categoryid int

set @categoryid = (SELECT CategoryID FROM CMS_WebPartCategory WHERE CategoryDisplayName='Membership')
if @categoryid<>0
begin
	INSERT [CMS_WebPart] ([WebPartName], [WebPartDisplayName], [WebPartDescription], [WebPartFileName], [WebPartProperties], [WebPartCategoryID]) VALUES ('changePassword', 'Change password', '', 'membership/changepassword.ascx', '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="MaximalPasswordLength" fieldcaption="Maximal password length" visible="true" defaultvalue="0" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="0" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /></form>', @categoryid)
end

GO

-- UPDATE WEBPART

UPDATE [CMS_WebPart] SET [WebPartProperties]='<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="CSSPrefix" fieldcaption="CSS prefix" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Cursor" fieldcaption="Cursor" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" columnsize="1" fielddescription="" defaultvalue="1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="0" text="Standard" /><item value="1" text="Hand" /></options></settings></field><field column="HighlightAllItemsInPath" fieldcaption="Highlight all items in path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="ExternalScriptPath" fieldcaption="External script path" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Layout" fieldcaption="Layout" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="vertical" text="Vertical" /><item value="horizontal" text="Horizontal" /></options></settings></field><field column="Padding" fieldcaption="Padding" visible="true" defaultvalue="2" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RenderItemName" fieldcaption="Render item name" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="Spacing" fieldcaption="Spacing" visible="true" defaultvalue="2" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubmenuIndicator" fieldcaption="Submenu indicator image" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted item" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="ApplyMenuDesign" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Menu item separator" /><field column="SeparatorCSS" fieldcaption="Separator CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SeparatorHeight" fieldcaption="Separator height" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SeparatorText" fieldcaption="Separator text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE [WebPartName]='cmsmenu'
UPDATE [CMS_WebPart] SET [WebPartProperties]='<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" defaultvalue="" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="4" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="DetailTransformation" fieldcaption="Detail transformation" visible="true" defaultvalue="cms.file.imagegallery-detail-600" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="ThumbnailTransformation" fieldcaption="Thumbnail transformation" visible="true" defaultvalue="cms.file.imagegallery-thumbnails-300" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Layout" /><field column="Columns" fieldcaption="Columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="RowsPerPage" fieldcaption="Rows per page" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelationshipName" fieldcaption="Relationship name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Related nodeIs on the left side" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE [WebPartName]='ImageGallery'
UPDATE [CMS_WebPart] SET [WebPartProperties]='<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ClassNames" fieldcaption="Document type" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="TransformationName" fieldcaption="Transformation name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Cache" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE [WebPartName]='randomDocument'
UPDATE [CMS_WebPart] SET [WebPartProperties]='<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="CSSPrefix" fieldcaption="CSS prefix" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="DisplayHighlightedItemAsLink" fieldcaption="Display highlighted item as link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="DisplayOnlySelectedPath" fieldcaption="Display only selected path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="FirstItemCssClass" fieldcaption="First item CSS class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="HighlightAllItemsInPath" fieldcaption="Highlight all items in path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="HoverCSSClassName" fieldcaption="LI hover CSS class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastItemCssClass" fieldcaption="Last item CSS class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOutScript" fieldcaption="OnMouseOut script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOverScript" fieldcaption="OnMouseOver script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderCssClasses" fieldcaption="Render CSS classes" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderItemID" fieldcaption="Render item ID" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderLinkTitle" fieldcaption="Render link title:" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="If true, renders the accessibility title attribute." regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ItemIdPrefix" fieldcaption="Item ID prefix" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubmenuIndicator" fieldcaption="Sub-menu indicator image" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UrlTarget" fieldcaption="Target frame" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted items" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="Apply menu design" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE [WebPartName]='cmslistmenu'

GO

-- CREATE INDEX ON CMS_SITE

UPDATE [CMS_Tree] SET [NodeGuid]=NEWID() WHERE NodeID IN 
(SELECT dup_rows.NodeID FROM CMS_Tree AS dup_rows
INNER JOIN
(
	SELECT NodeGUID, NodeSiteID, MIN(NodeID) AS min_id
	FROM CMS_Tree
	GROUP BY NodeGUID, NodeSiteID
	HAVING COUNT(*) > 1
) AS rows_to_update
ON rows_to_update.NodeGUID = dup_rows.NodeGUID AND
   rows_to_update.NodeSiteID = dup_rows.NodeSiteID AND
   rows_to_update.min_id <> dup_rows.NodeID)

GO

declare @docindexexists int

set @docindexexists = (SELECT count(name) FROM sysindexes WHERE name = 'IX_CMS_Tree_NodeGUID_NodeSiteID')
if @docindexexists=0
begin
	CREATE UNIQUE NONCLUSTERED INDEX [IX_CMS_Tree_NodeGUID_NodeSiteID] ON [CMS_Tree] ([NodeSiteID], [NodeGUID]) ON [PRIMARY]
end

GO